/***********************************************************************************************
 * BankFailUtils.h
 * Header (include) file with Structures and Enums used in BankFail.cpp
 * Created May 31 2010
 *
 * Copyright (C) 2010, Quamrul Ashraf, Department of Economics, Williams College, and 
 * Boris Gershman and Peter Howitt, Department of Economics, Brown University.
 * All rights reserved.
 ***********************************************************************************************/
#ifndef BANKFAILLUTILS_H
#define BANKFAILLUTILS_H

struct BankParameters {
  int INIPRD; int NGOODS; 
  int NBANKS; int WKSPYR;
  double BKRCST; double SPREAD; 
  double DISCPR; double PSLOPE;
};
struct ShopParameters {
  int FLEXWG; int CNTPRD; int WKSPYR;
  double FXDCST; double INVSPD;
  double WAGSPD; double LTRIGG;
  double PDELTA; double FAILRT;
  double PITRGY; double BRKFRC;
};
struct AgentParameters {
  int NGOODS, WKSPYR;
  int MAXSLS, RNDMRK, CNTPRD; 
  double FXDCST; double MARKUP; 
  double DMDELS; double SRCHPP; 
  double PITRGY; double TMPRFY;
  double SETUPC; double INCSPD;
};
enum UnType {	// declaration of unemployment type
  None,	  // 0. not applicable
  Layoff,	// 1. agent laid off by employer
  Quit,		// 2. agent quit his job
  Exit,		// 3. employer exited the market
  Broke		// 4. employer became broke
};

#endif // BANKFAILLUTILS_H