/***********************************************************************************************
 * Firesale.h
 * Header (include) file for the Firesale class.
 * Revised May 25 2010
 *
 * Copyright (C) 2009, Peter Howitt and Quamrul Ashraf, Dept. of Economics, Brown University.
 * All rights reserved.
 ***********************************************************************************************/

#include <queue>
using namespace std;
class Agent;          // forward declaration of Agent

#ifndef FIRESALE_H
#define FIRESALE_H

typedef queue<Agent*> agentQueue;

class Firesale {
	agentQueue fQueue;	// the queue of firesale suppliers
  int _gIndex;        // index of the good sold

public:
	Firesale(int gdIndx);
	~Firesale();
  Agent* dbg_chkDup(); // checks for duplicate seller name
  void ini_frsale(); // initialize the firesale for new run
	void add_seller(Agent* seller);	// add a seller to the queue of firesale suppliers
  void drop_sellr(Agent* seller);	// drop seller from the queue of firesale suppliers
	double run_frsale(double fOrder);	// run a firesale (returns the quantity transacted)
  const double get_supply(); // returns total supply in the queue
};

#endif // FIRESALE_H