/***********************************************************************************************
 * RandUtils.h
 * Class implementing static utility interfaces to the random number generator.
 * Created July 24, 2007.
 * Revised March 10 2009
 *
 * Copyright (C) 2007, Peter Howitt and Quamrul Ashraf, Dept. of Economics, Brown University.
 * All rights reserved.
 ***********************************************************************************************/

#include <stdlib.h>

#ifndef RANDUTILS_H
#define RANDUTILS_H

class RandUtils {
public:
	static void set_RnSeed(int RnSeed) {
		srand(RnSeed);
	}

  // get_RnLess(u) returns a random element of the set {0, 1, ..., u-1}
	static int get_RnLess(int uBound) {
		return (uBound * rand() / (RAND_MAX + 1));
	}

	static double get_RnFrac() {
		return ((double) rand() / (RAND_MAX + 1));
	}
};

#endif // RANDUTILS_H
